import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Displays the health of the boss.
 * 
 * @author Tzanis Aristeidis 
 * @version 1.0
 */
public class BossHealth  extends Actor
{ 

    private GreenfootImage aImage =  new GreenfootImage(70, 5);
    private int theHealth = 0;
    
    /**
     * The Constructor.
     */
    public BossHealth(){
        showHealthBar();  
    }
    
    /**
     * Returns the health at any time.
     */
    public int getHealth(){
        return theHealth;
    }
    
    /**
     * Initial health.
     */
    private void showHealthBar(){
        aImage.setColor(Color.GREEN);
        aImage.fillRect(0,0, 70, 5);
        setImage(aImage);
    }
    
    /**
     * Decreases the health by "health"
     * @health The ammount of health he is loosing.
     */
    public void hit(int health){
        theHealth += health;
        aImage.setColor(Color.RED);
        aImage.fillRect(70-theHealth,0, theHealth, 5); 
        setImage(aImage);
    }
}
