import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Cop here.
 * 
 * @author Tzanis Aristeidis
 * @version 1.0
 */
public class Cop  extends Mover
{
    private boolean theDying = false;
    private boolean disappearCop = false;
    public boolean isDead = false;
    
    private GreenfootImage[] walking;//the walking images.
    private GreenfootImage[] dying;//the dying images.
    private GreenfootImage[] hiting;//and the hitting images.
    private static final int DAMAGE = 5;
    private static final int SCORE = 5;
    private static final int MONEY = 10;
    
    private int imageNo = 0;
    private int counter = 0;    
    private int dyingImageNo = 0;
    private int dyingCounter=0;
    private int disappearCounter = 255;
    
    private Base theBase;
    private Jack jack;
    
    /**
     * The constructor.
     */
    public Cop(){
        setupWalking(6);
        setupDying(4);
        setupHiting(4);
    }
    
    public void act() 
    {
        TheStreet ts = (TheStreet)getWorld();
        if(!ts.isShopOpen){
            if (theDying == true){
                dyingAnimation(6);
            }else if(disappearCop == true){     
                disappear(5);
            }else{
                 walk(6);
                 //sort(getIntersectingObjects(Cop.class));
            }      
        }
    }   /*
    
            for (int i=0; i<x.size()-1; i++){
                System.out.println(i);
                Cop cop = (Cop)x.get(i);
                Cop cop1 = (Cop)x.get(i+1);
                getWorld().setPaintOrder(cop.getClass(),cop1.getClass());
            }*/
    private void sort(List x){
        if(x!=null){
        int n = x.size();
        for (int pass=1; pass < n; pass++) {  // count how many times
            // This next loop becomes shorter and shorter
            for (int i=0; i < n-pass; i++) {
                System.out.println(i);
                Cop cop = (Cop)x.get(i);
                Cop cop1 = (Cop)x.get(i+1);
                if (cop.getX() > cop1.getX()) {
                    // exchange elements
                    Cop temp = (Cop)x.get(i);  
                    x.set(i,x.get(i+1));  
                    x.set(i+1, temp);
                }
            }
            for (int i=0; i<x.size()-1; i++){
                System.out.println(i);
                Cop cop = (Cop)x.get(i);
                Cop cop1 = (Cop)x.get(i+1);
                getWorld().setPaintOrder(cop.getClass(),cop1.getClass());
            }
        }}
    }
    /**
     * Initialize the walking animation.
     */
    private void setupWalking(int frames){
        walking = new GreenfootImage[frames];
        walking[0] = new GreenfootImage("images/cop4wglop.png");
        walking[1] = new GreenfootImage("images/cop2wglop.png");
        walking[2] = new GreenfootImage("images/cop4wglop.png");
        walking[3] = new GreenfootImage("images/cop3wglop.png");
        walking[4] = new GreenfootImage("images/cop1wglop.png");
        walking[5] = new GreenfootImage("images/cop3wglop.png");
    }
    
    /**
     * Initialize the dying animation.
     */    
    private void setupDying(int frames){
        dying = new GreenfootImage[frames];
        dying[0] = new GreenfootImage("images/cop1dying.png");
        dying[1] = new GreenfootImage("images/cop2dying.png");
        dying[2] = new GreenfootImage("images/cop3dying.png");
        dying[3] = new GreenfootImage("images/cop4dying.png");
    }
    
    /**
     * Initialize the hiting animation.
     */    
    private void setupHiting(int frames){
        hiting = new GreenfootImage[frames];
        hiting[0] = new GreenfootImage("images/cop1hit.png");
        hiting[1] = new GreenfootImage("images/cop2hit.png");
        hiting[2] = new GreenfootImage("images/cop3hit.png");
        hiting[3] = new GreenfootImage("images/cop2hit.png");   
    }
    
    /**
     * The cop walking.
     */
    private void walk(int speed)
    {
        if (!goForTheBase())
        {
            setSpeed(new Vector(0, speed));
            move();
            if (counter%6==0){
                setImage(walking[imageNo]);
                imageNo ++;
                if (imageNo==walking.length)
                {
                    imageNo = 0;
                }
            }counter++;
        }else{
            if (counter%6==0){
                setImage(hiting[imageNo]);
                imageNo ++;
                if (imageNo==hiting.length)
                {
                    theBase.setHealth(theBase.getHealth()+DAMAGE);
                    imageNo = 0;
                }
            }counter++;
        }
    }
    
    /**
     * Check if the cop is intersecting with the base.
     */
    private boolean goForTheBase()
    {
        theBase = (Base) getOneIntersectingObject(Base.class);
        if(theBase == null){
            //Greenfoot.playSound("hittingTheBase.wav");
            return false;
        }else{
            return true;
        }
    }
    
    /**
     * Enable the dying animation.
     */    
    public void die()
    {
        Greenfoot.playSound("LeftHook.wav");
        jack = (Jack)getWorld().getObjects(Jack.class).get(0);
        jack.setScore(jack.getScore()+SCORE);
        jack.setMoney(jack.getMoney()+MONEY);
        this.theDying = true;
    }
    
    /**
     * The cop dying.
     */
    private void dyingAnimation(int speed){        
        if (dyingCounter%speed==0){
            setImage(dying[dyingImageNo]);
            dyingImageNo ++;
            if (dyingImageNo==dying.length){
                theDying = false;
                disappearCop = true;
                dyingImageNo = 0;
            }else{

            }
        }dyingCounter++;
    }
    
    /**
     * Smoothly remove the dead cop.
     */
    private void disappear(int speed){
        this.getImage().setTransparency(disappearCounter);
        disappearCounter = disappearCounter - speed;
        if (disappearCounter ==0){
            disappearCop = false;
            getWorld().removeObject(this);
        }
    }
}
