import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Mat here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Mat  extends Mover
{
    private boolean theDying = false;
    private boolean disappearMat = false;
    public boolean isDead = false;
    
    private GreenfootImage[] walking;//the walking images.
    private GreenfootImage[] dying;//the dying images.
    private GreenfootImage[] hiting;//and the hitting images.
    private static final int DAMAGE = 7;
    private static final int SCORE = 10;
    private static final int MONEY = 20;
    
    private int imageNo = 0;
    private int counter = 0;    
    private int dyingImageNo = 0;
    private int dyingCounter=0;
    private int disappearCounter = 255;
    
    private Base theBase;
    private Jack jack;
    
    /**
     * The constructor.
     */
    public Mat(){
        setupWalking(6);
        setupDying(4);
        setupHiting(4);
    }
    
    public void act() 
    {
        TheStreet ts = (TheStreet)getWorld();
        if(!ts.isShopOpen){
            if (theDying == true){
                dyingAnimation(6);
            }else if(disappearMat == true){     
                disappear(5);
            }else{
                 walk(6);
            }      
        }
    }   
    
    /**
     * Initialize the walking animation.
     */
    private void setupWalking(int frames){
        walking = new GreenfootImage[frames];
        walking[0] = new GreenfootImage("images/mat4wglop.png");
        walking[1] = new GreenfootImage("images/mat2wglop.png");
        walking[2] = new GreenfootImage("images/mat4wglop.png");
        walking[3] = new GreenfootImage("images/mat3wglop.png");
        walking[4] = new GreenfootImage("images/mat1wglop.png");
        walking[5] = new GreenfootImage("images/mat3wglop.png");
    }
    
    /**
     * Initialize the dying animation.
     */    
    private void setupDying(int frames){
        dying = new GreenfootImage[frames];
        dying[0] = new GreenfootImage("images/mat1dying.png");
        dying[1] = new GreenfootImage("images/mat2dying.png");
        dying[2] = new GreenfootImage("images/mat3dying.png");
        dying[3] = new GreenfootImage("images/mat4dying.png");
    }
    
    /**
     * Initialize the hiting animation.
     */    
    private void setupHiting(int frames){
        hiting = new GreenfootImage[frames];
        hiting[0] = new GreenfootImage("images/mat1hit.png");
        hiting[1] = new GreenfootImage("images/mat2hit.png");
        hiting[2] = new GreenfootImage("images/mat3hit.png");
        hiting[3] = new GreenfootImage("images/mat2hit.png");   
    }
    
    /**
     * The mat walking.
     */
    private void walk(int speed)
    {
        if (!goForTheBase())
        {
            setSpeed(new Vector(0, speed));
            move();
            if (counter%6==0){
                setImage(walking[imageNo]);
                imageNo ++;
                if (imageNo==walking.length)
                {
                    imageNo = 0;
                }
            }counter++;
        }else{
            if (counter%6==0){
                setImage(hiting[imageNo]);
                imageNo ++;
                if (imageNo==hiting.length)
                {
                    theBase.setHealth(theBase.getHealth()+DAMAGE);
                    imageNo = 0;
                }
            }counter++;
        }
    }
    
    /**
     * Check if the mat is intersecting with the base.
     */
    private boolean goForTheBase()
    {
        theBase = (Base) getOneIntersectingObject(Base.class);
        if(theBase == null){
            //Greenfoot.playSound("hittingTheBase.wav");
            return false;
        }else{
            return true;
        }
    }
    
    /**
     * Enable the dying animation.
     */    
    public void die()
    {
        Greenfoot.playSound("LeftHook.wav");
        jack = (Jack)getWorld().getObjects(Jack.class).get(0);
        jack.setScore(jack.getScore()+SCORE);
        jack.setMoney(jack.getMoney()+MONEY);
        this.theDying = true;
    }
    
    /**
     * The mat dying.
     */
    private void dyingAnimation(int speed){        
        if (dyingCounter%speed==0){
            setImage(dying[dyingImageNo]);
            dyingImageNo ++;
            if (dyingImageNo==dying.length){
                theDying = false;
                disappearMat = true;
                dyingImageNo = 0;
            }else{

            }
        }dyingCounter++;
    }
    
    /**
     * Smoothly remove the dead mat.
     */
    private void disappear(int speed){
        this.getImage().setTransparency(disappearCounter);
        disappearCounter = disappearCounter - speed;
        if (disappearCounter ==0){
            disappearMat = false;
            getWorld().removeObject(this);
        }
    }  
}
