import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Pig here.
 * 
 * @author Tzanis Aristeidis 
 * @version (a version number or a date)
 */
public class Pig  extends Mover
{
    private boolean edge = false;
    private boolean up = true;
    private int counter;
    private Vector upVector;//the vectors for the players movement.
    private Vector downVector;
    private BossHealth bossHealth= new BossHealth();
    public boolean pos = false;
    private int i=0;
    private GreenfootImage[] fireImage;
    
    public Pig(){
        this.downVector = new Vector(90, 3);
        this.upVector = new Vector(-90, 3);
        setSpeed(upVector);
        setupShooting();
    }
    
    public void act(){
        TheStreet ts = (TheStreet)getWorld();
        if(!ts.isShopOpen){
            if(getY()>360)
                edge = true;
            else if(getY()<270)
                edge = true;
            else
                edge = false;
            if (edge){
                changeDirection();
            }
            move();
            if (counter%10==0){
                setImage(fireImage[i]);
                i++;
                if (i == fireImage.length) i=0;
                shoot();
            }counter++;
            showHealthBar();
        }
    }
    /**
     * Change the direction.
     */
    private void changeDirection(){
        if(up){
            up = false;
            setSpeed(downVector);
            shoot();}
        else{
            up = true;
            setSpeed(upVector);}
    }
    
    /**
     * Creates a bullet.
     */
    private void shoot(){
        BossBullet bullet = new BossBullet();
        getWorld().addObject(bullet, 110, getY());
    }
    
    private void setupShooting(){
        fireImage = new GreenfootImage[2];
        fireImage[0] = new GreenfootImage("pigfire.png");
        fireImage[1] = new GreenfootImage("pig.png");
    }
    /**
     * Returns the health.
     */
    public int getHealth(){
        return bossHealth.getHealth();
    }
    
    /**
     * Creates the health bar.
     */
    private void showHealthBar(){
        if(!pos){
            getWorld().addObject(bossHealth,40,getY()-55);
            pos = true;
        }bossHealth.setLocation(40,getY()-55);
    }
    
    /**
     * Lowers his health.
     * @damage The ammount of health to take.
     */
    public void hit(int damage){
        bossHealth.hit(damage);
    }
}
