import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
import java.util.List;
/**
 * Write a description of class Shop here.
 * 
 * @author Tzanis Aristeidis
 * @version 1.0
 */
public class Shop  extends Actor
{
    public static final float FONT_SIZE = 16.0f;
    public static final int WIDTH = 300;
    public static final int HEIGHT = 230;
    public static final int LEVEL_FOR_DESK = 2;
    public static final int LEVEL_FOR_BOMB = 4;
    public static final int LEVEL_FOR_GUN = 6;
    
    private Jack jack;
    
    /**
     * The Constructor.
     */
    public Shop()
    {
        makeImage(" - The Shop - ","Desk,Bomb,Gun".split("[,]"),"200$,300$,400$".split("[,]"));
    }
    
    /**
     * Create a score board for the final result.
     * @title The title of the shop.
     * @items The items seperated with commas.
     * @prices The prices seperated with commas.
     * @jack Jack.
     */
    public Shop(String title, String items, String prices, Jack jack)
    {
        this.jack = jack;
        makeImage(title, items.split("[,]"),prices.split("[,]"));
    }
    
    /**
     * Make the score board image.
     * @title The title of the shop.
     * @theItems An array with the item names.
     * @thePrices An array with the prices for each item.
     */
    private void makeImage(String title, String[] theItems, String[] thePrices)
    {
        int avail = 0;//the available weapons.
        int y = 75;
        GreenfootImage image = new GreenfootImage(WIDTH, HEIGHT);
        GreenfootImage[] thumbs = new GreenfootImage[theItems.length];
        thumbs[0] = new GreenfootImage("images/deskThumb.png");
        thumbs[1] = new GreenfootImage("images/bombThumb.png");
        thumbs[2] = new GreenfootImage("images/gunThumb.png");
        image.setColor(new Color(0, 0, 0, 128));
        image.fillRect(0, 0, WIDTH, HEIGHT);
        image.setColor(new Color(0, 0, 0, 128));
        image.fillRect(5, 5, WIDTH-10, HEIGHT-10);
        Font font = image.getFont();
        font = font.deriveFont(FONT_SIZE);
        image.setFont(font);
        image.setColor(Color.WHITE);
        image.drawString(title, 100, 30);
        
        if (jack.getLevel()>=LEVEL_FOR_DESK)avail=1;
        if (jack.getLevel()>=LEVEL_FOR_BOMB)avail=2;
        if (jack.getLevel()>=LEVEL_FOR_GUN)avail=3;
        
        for(int i =0; i<avail;i++){
            image.drawString(theItems[i]+":", 60, y);
            image.drawImage(thumbs[i],115,y-30);
            image.drawString(thePrices[i], 170, y);
            y+=40;
        }setImage(image);
    }
}
