import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
/**
 * Write a description of class TheStreet here.
 * 
 * @author Tzanis Aristeidis
 * @version 1.0
 */
public class TheStreet  extends World
{
    private int counter;
    private Base theBase;
    private boolean gameEnded = false;
    public boolean isShopOpen = false;
    private boolean isBossOut=false;
    private int jackMoney;
    private int mix;
    
    private static final int AMMOUNT_OF_DESKS = 10;//Ammount of desks per price.
    private static final int AMMOUNT_OF_BOMBS = 1;//Ammount of bombs per price.
    private static final int AMMOUNT_OF_BULLETS = 100;//Ammount of bullets per price.
    private static final int ITEM1_PRICE = 20;
    private static final int ITEM2_PRICE = 40;
    private static final int ITEM3_PRICE = 60;
    private static final String ITEM1 = "desk";
    private static final String ITEM2 = "bomb";
    private static final String ITEM3 = "gun";
    private static final int LEVEL_FOR_MAT = 3;
    private static final int LEVEL_FOR_COPS_TO_STOP = 6;
    private static final int LEVEL_FOR_BOSS = 8;
    
    
    //the same is be in the shop
    //TODO: shouldnt be in the shop and in the street.
    public static final int LEVEL_FOR_DESK = 2;//Set the level where the item is available.
    public static final int LEVEL_FOR_BOMB = 4;
    public static final int LEVEL_FOR_GUN =  6;
    
    private Jack jack;
    private Pig boss;
    /**
     * Constructor for objects of class TheStreet.
     */
    public TheStreet()
    {    
        super(1000, 400, 1);
        this.theBase = new Base();
        this.jackMoney = 0;
        createMain();
    }
    
    /**
     * Creates the main components of the game (theBase, Jack, theFence, the BuyButton and the Next button.
     */
    private void createMain(){
        addObject(theBase, 786,337);
        addObject(new Jack(), 842,315);
        jack = (Jack)getObjects(Jack.class).get(0);
        addObject(new LowerFence(),838 ,386);
        addObject(new BuyButton(),941,148);
        addObject(new Next(), 948, 75);
        theBase.initHealth();
        initializePlayerInfo();
        jack.currentWeapon("chair");
    }
    /**
     * First Information Score:0, Level:1, Money:0.
     */
    private void initializePlayerInfo(){
        GreenfootImage scoreImage = getBackground();
        Font font = scoreImage.getFont();
        font = font.deriveFont(12.0f);
        scoreImage.setFont(font);
        scoreImage.setColor(new Color(76, 74, 44));
        scoreImage.fillRect(890,22,35,15);
        scoreImage.setColor(Color.WHITE);
        scoreImage.drawString(String.valueOf(0), 910, 34);
        scoreImage.setColor(Color.WHITE);
        scoreImage.drawString(String.valueOf(1), 910, 53);
        scoreImage.setColor(Color.YELLOW);
        scoreImage.drawString(String.valueOf(0), 870, 154);
    }
    
    /**
     * The act method. 
     */
    public void act(){
        //Creates the cops with a small delay and stops when the game ends.
        if (counter%40==0&&!gameEnded&&!isBossOut){
            mix++;
            if(jack.getLevel()<LEVEL_FOR_MAT)
                createCops();
            if(jack.getLevel()>=LEVEL_FOR_MAT&&jack.getLevel()<LEVEL_FOR_COPS_TO_STOP&&mix%2==0)
                createCops();
            if(jack.getLevel()>=LEVEL_FOR_MAT&&jack.getLevel()<LEVEL_FOR_COPS_TO_STOP&&mix%2==1)
                createMat();
            if(jack.getLevel()>=LEVEL_FOR_COPS_TO_STOP&&jack.getLevel()<LEVEL_FOR_BOSS)
                createMat();
        }
        counter++;
        //Creates the Pig when Jack reaches a certain level.
        if(jack.getLevel()>=LEVEL_FOR_BOSS){
            createBoss();
            isBossOut=true;
        }
        //When the boss is out, checks both healths, to call the game.
        if(isBossOut){
            boss = (Pig)getObjects(Pig.class).get(0);
            if(!getObjects(JackHealth.class).isEmpty()){
                if(jack.getHealth()>=70 && !gameEnded) this.setScoreboard("Sorry Jack","You lost");
                if(boss.getHealth()>=70){
                    this.setScoreboard("Dude","You Won!!!");
                    removeObject(boss);
                }
            }
        }
        //Ends the game when the health goes to 70.
        if(theBase.getHealth()>=70 && !gameEnded){
            this.setScoreboard("Sorry Jack","You lost");
        }
        
        //Opens the shop
        if(Greenfoot.mouseClicked(getObjects(BuyButton.class).get(0)) && !isShopOpen){
            startShop();
            jackMoney = jack.getMoney();
            isShopOpen = true;
        }
        
        //Goes to next weapon.
        if(Greenfoot.mouseClicked(getObjects(Next.class).get(0))){
            jack.nextItem();
        }
        
        if(isShopOpen){
            
            if(getObjects(BuyButton.class).size()>1){
                if(Greenfoot.mouseClicked(getObjects(BuyButton.class).get(1))){
                    if(jackMoney>=ITEM1_PRICE) buyItem(ITEM1,ITEM1_PRICE); 
                }
            }
            if(getObjects(BuyButton.class).size()>2){
                if(Greenfoot.mouseClicked(getObjects(BuyButton.class).get(2))){
                    if(jackMoney>=ITEM2_PRICE) buyItem(ITEM2,ITEM2_PRICE); 
                }
            }   
            if(getObjects(BuyButton.class).size()>3){
                if(Greenfoot.mouseClicked(getObjects(BuyButton.class).get(3))){
                    if(jackMoney>=ITEM3_PRICE) buyItem(ITEM3,ITEM3_PRICE); 
                }
            }
            if(Greenfoot.mouseClicked(getObjects(CloseButton.class).get(0))){
                stopShop(); 
            }    
        }
    }  

    /**
     * Creates a new Shop with the weapons and the prices.
     */
    private void startShop(){
        Shop shop = new Shop(" - The Shop - ","Desk,Bomb,Gun",
            String.valueOf(ITEM1_PRICE)+"$,"+
            String.valueOf(ITEM2_PRICE)+"$,"+
            String.valueOf(ITEM3_PRICE)+"$",jack);
        addObject(shop, 500, 120);
        addObject(new CloseButton(), 580, 30);
        
        //Checks Jacks level to make the weapons available.
        if(jack.getLevel()>=LEVEL_FOR_DESK)addObject(new BuyButton(), 590, 70);
        if(jack.getLevel()>=LEVEL_FOR_BOMB)addObject(new BuyButton(), 590, 110);
        if(jack.getLevel()>=LEVEL_FOR_GUN)addObject(new BuyButton(), 590, 150);
    }
    
    /**
     * Removes the Shop and the components.
     */
    private void stopShop(){
        isShopOpen = false;
        removeObject((CloseButton)getObjects(CloseButton.class).get(0));
        removeObject((Shop)getObjects(Shop.class).get(0));
        removeObjects(getObjects(BuyButton.class));
        addObject(new BuyButton(),941,148);
    }
    
    /**
     * Adds an item to jacks inventory, lowers his money and adds some bullets to the weapon he bought.
     * @itemName The name of the weapon.
     * @price The price of the weapon.
     */
    private void buyItem(String itemName, int price){
        if(jack.getMoney()>0){
            jack.addItemToInventory(itemName);
            jack.setMoney(jack.getMoney()-price);
            if(itemName == "desk"){
                jack.addBullets(itemName,AMMOUNT_OF_DESKS);
            }
            if(itemName == "bomb"){
                jack.addBullets(itemName,AMMOUNT_OF_BOMBS);
            }
            if(itemName == "gun"){
                jack.addBullets(itemName,AMMOUNT_OF_BULLETS);
            }
        }
    }
    
    /**
     * When the game ends, shows a message, the final score and removes some objects.
     */
    private void setScoreboard(String first, String second){
            gameEnded = true;
            ScoreBoard board = new ScoreBoard(first,second, "Score: ", jack.getScore());
            removeObjects(getObjects(Cop.class));
            removeObjects(getObjects(Jack.class));  
            removeObjects(getObjects(Mat.class));
            addObject(board, getWidth() / 2, getHeight() / 2);
            if(isShopOpen)stopShop(); 
            //removeObjects(getObjects(BuyButton.class)); //TODO: If enabled throws a retarted error. 
    }
    
    /**
     * Creates the standar cops.
     */
    private void createCops(){
        if(!isShopOpen){
            int finalRandomNumber = 0;
            int aRandomNumber = 0;
            Cop cop = new Cop();
            aRandomNumber = Greenfoot.getRandomNumber(68)+292;
            if(finalRandomNumber <= aRandomNumber){
                finalRandomNumber = aRandomNumber;
                this.addObject(cop,0, finalRandomNumber);
            }else{
                this.addObject(cop,0, finalRandomNumber);
            }
        }
    }
    
    /**
     * Creates the standar cops.
     */
    private void createBoss(){
            if(!isBossOut)this.addObject(new Pig(),50, Greenfoot.getRandomNumber(68)+292);
    }    
    
    /**
     * Creates the standar cops.
     */
    private void createMat(){
        if(!isShopOpen){
            int finalRandomNumber = 0;
            int aRandomNumber = 0;
            Mat mat = new Mat();
            aRandomNumber = Greenfoot.getRandomNumber(68)+292;
            if(finalRandomNumber <= aRandomNumber){
                finalRandomNumber = aRandomNumber;
                this.addObject(mat,0, finalRandomNumber);
            }else{
                this.addObject(mat,0, finalRandomNumber);
            }
        }
    }
}
